: To unbundle, sh this file
echo _divsi3.asm
cat >_divsi3.asm <<'@@@ Fin de _divsi3.asm'
LL0:
	.data
	.text
	.proc
|#PROC# 04
	.globl	___divsi3
___divsi3:
|#PROLOGUE# 0
	link	a6,#0
	addl	#-LF14,sp
	moveml	#LS14,sp@
|#PROLOGUE# 1
	moveb	#1, d4		/* sign of result stored in d4 (=1 or =-1) */
	movel	a6@(0xc), d0	/* d0 = divisor */
	bpl	l1
	negl	d0
	negb	d4		/* change sign because divisor <0  */
l1:	movel	d0, d2
	movel	a6@(0x8), d1	/* d1 = dividend */
	bpl	l2
	negl	d1
	negb	d4
l2:	movel	d1, d3


	cmpl	#0x10000, d0	/* divisor >= 2 ^ 16 ?   */
	bge	l4		/* then try next algorithm */
	lsrl	#8, d1		/* get high dividend */
	lsrl	#8, d1
	divu	d0, d1          /* high quotient */
	swap	d1
	divu	d0, d3		/* low quotient */
	movew	d3, d1
	jra	l5

l4:	lsrl	#1, d0		/* shift divisor */
	lsrl	#1, d1		/* shift dividend */
	cmpl	#0x10000, d0	/* still divisor >= 2 ^ 16 ?  */
	bge	l4
	divu	d0, d1		/* now we have 16bit divisor => compute remainder */
	andl	#0xffff, d1
	movel	d1, sp@-	/* multiply divisor with */
	movel	d2, sp@-	/* remainder             */
	jbsr	___umulsi3	/* and                   */
	addql	#8, sp
	cmpl	d0, d3		/* compare the result with the dividend */
	bge	l5		/* if dividend >= result => nofix */
	subql	#1, d1

l5:	movel	d1, d0	
	tstb	d4
	bpl	l6
	negl	d0

l6:	jra	LE14
LE14:
|#PROLOGUE# 2
	moveml	sp@, #LS14
	unlk	a6
|#PROLOGUE# 3
	rts
	LF14 = 16
	LS14 = 0x001e		/* d1-d4 will be saved and restored */
	LFF14 = 8
	LSS14 = 0x0
	LV14 = 8
	.data
@@@ Fin de _divsi3.asm
echo _modsi3.asm
cat >_modsi3.asm <<'@@@ Fin de _modsi3.asm'
LL0:
	.data
	.text
	.proc
|#PROC# 04
	.globl	___modsi3
___modsi3:
|#PROLOGUE# 0
	link	a6,#0
	addl	#-LF14,sp
	moveml	#LS14,sp@
|#PROLOGUE# 1
	movel	a6@(0xc),d1	/* divisor */
	movel	a6@(0x8),d2	/* dividend */
	movel	d1, sp@-
	movel	d2, sp@-
	jbsr	___divsi3	/* d0 = a/b */
	addql	#8, sp
	movel	d0, sp@-
	movel	d1, sp@-
	jbsr	___mulsi3	/* d0 = (a/b)*b */
	addql	#8, sp
	negl	d0
	addl	d2, d0		/* d0 = a - (a/b)*b */
	jra	LE14
LE14:
|#PROLOGUE# 2
	moveml	sp@, #LS14
	unlk	a6
|#PROLOGUE# 3
	rts
	LF14 = 8
	LS14 = 0x006		/* d1-d2 will be saved and restored */
	LFF14 = 0
	LSS14 = 0x0
	LV14 = 0
	.data
@@@ Fin de _modsi3.asm
echo _mulsi3.asm
cat >_mulsi3.asm <<'@@@ Fin de _mulsi3.asm'
LL0:
	.data
	.text
	.proc
|#PROC# 04
	.globl	___mulsi3
___mulsi3:
|#PROLOGUE# 0
	link	a6,#0
	addl	#-LF14,sp
	moveml	#LS14,sp@
|#PROLOGUE# 1
	movew	a6@(0x8), d0	/* x0 -> d0 */
	muluw	a6@(0xe), d0	/* x0*y1 */
	movew	a6@(0xa), d1	/* x1 -> d1 */
	muluw	a6@(0xc), d1	/* x1*y0 */
	addw	d1, d0
	lsll	#8, d0
	lsll	#8, d0
	movew	a6@(0xa), d1	/* x1 -> d1 */
	muluw	a6@(0xe), d1	/* x1*y1 */
	addl	d1, d0
	jra	LE14
LE14:
|#PROLOGUE# 2
	moveml	sp@, #LS14
	unlk	a6
|#PROLOGUE# 3
	rts
	LF14 = 4
	LS14 = 0x0002		/* d1 will be saved and restored */
	LFF14 = 0
	LSS14 = 0x0
	LV14 = 0
	.data
@@@ Fin de _mulsi3.asm
echo _udivsi3.asm
cat >_udivsi3.asm <<'@@@ Fin de _udivsi3.asm'
LL0:
	.data
	.text
	.proc
|#PROC# 04
	.globl	___udivsi3
___udivsi3:
|#PROLOGUE# 0
	link	a6,#0
	addl	#-LF14,sp
	moveml	#LS14,sp@
|#PROLOGUE# 1
	movel	a6@(0xc), d0	/* d0 = divisor */
	movel	d0, d2
	movel	a6@(0x8), d1	/* d1 = dividend */
	movel	d1, d3


	cmpl	#0x10000, d0	/* divisor >= 2 ^ 16 ?   */
	bge	l4		/* then try next algorithm */
	lsrl	#8, d1		/* get high dividend */
	lsrl	#8, d1
	divu	d0, d1          /* high quotient */
	swap	d1
	divu	d0, d3		/* low quotient */
	movew	d3, d1
	jra	l5

l4:	lsrl	#1, d0		/* shift divisor */
	lsrl	#1, d1		/* shift dividend */
	cmpl	#0x10000, d0	/* still divisor >= 2 ^ 16 ?  */
	bge	l4
	divu	d0, d1		/* now we have 16bit divisor => compute remainder */
	andl	#0xffff, d1
	movel	d1, sp@-	/* multiply divisor with */
	movel	d2, sp@-	/* remainder             */
	jbsr	___umulsi3	/* and                   */
	addql	#8, sp
	cmpl	d0, d3		/* compare the result with the dividend */
	bge	l5		/* if dividend >= result => nofix */
	subql	#1, d1

l5:	movel	d1, d0	
	tstb	d4
	bpl	l6
	negl	d0

l6:	jra	LE14
LE14:
|#PROLOGUE# 2
	moveml	sp@, #LS14
	unlk	a6
|#PROLOGUE# 3
	rts
	LF14 = 16
	LS14 = 0x001e		/* d1-d4 will be saved and restored */
	LFF14 = 0
	LSS14 = 0x0
	LV14 = 0
	.data
@@@ Fin de _udivsi3.asm
echo _umodsi3.asm
cat >_umodsi3.asm <<'@@@ Fin de _umodsi3.asm'
LL0:
	.data
	.text
	.proc
|#PROC# 04
	.globl	___umodsi3
___umodsi3:
|#PROLOGUE# 0
	link	a6,#0
	addl	#-LF14,sp
	moveml	#LS14,sp@
|#PROLOGUE# 1
	movel	a6@(0xc),d1	/* divisor */
	movel	a6@(0x8),d2	/* dividend */
	movel	d1, sp@-
	movel	d2, sp@-
	jbsr	___udivsi3	/* d0 = a/b */
	addql	#8, sp
	movel	d0, sp@-
	movel	d1, sp@-
	jbsr	___umulsi3	/* d0 = (a/b)*b */
	addql	#8, sp
	negl	d0
	addl	d2, d0		/* d0 = a - (a/b)*b */
	jra	LE14
LE14:
|#PROLOGUE# 2
	moveml	sp@, #LS14
	unlk	a6
|#PROLOGUE# 3
	rts
	LF14 = 8
	LS14 = 0x006		/* d1-d2 will be saved and restored */
	LFF14 = 0
	LSS14 = 0x0
	LV14 = 0
	.data
@@@ Fin de _umodsi3.asm
echo _umulsi3.asm
cat >_umulsi3.asm <<'@@@ Fin de _umulsi3.asm'
LL0:
	.data
	.text
	.proc
|#PROC# 04
	.globl	___umulsi3
___umulsi3:
|#PROLOGUE# 0
	link	a6,#0
	addl	#-LF14,sp
	moveml	#LS14,sp@
|#PROLOGUE# 1
	movew	a6@(0x8), d0	/* x0 -> d0 */
	muluw	a6@(0xe), d0	/* x0*y1 */
	movew	a6@(0xa), d1	/* x1 -> d1 */
	muluw	a6@(0xc), d1	/* x1*y0 */
	addw	d1, d0
	lsll	#8, d0
	lsll	#8, d0
	movew	a6@(0xa), d1	/* x1 -> d1 */
	muluw	a6@(0xe), d1	/* x1*y1 */
	addl	d1, d0
	jra	LE14
LE14:
|#PROLOGUE# 2
	moveml	sp@, #LS14
	unlk	a6
|#PROLOGUE# 3
	rts
	LF14 = 4
	LS14 = 0x0002		/* d1 will be saved and restored */
	LFF14 = 0
	LSS14 = 0x0
	LV14 = 0
	.data
@@@ Fin de _umulsi3.asm
exit 0
