/*
 * Copyright (c) 1988 The Regents of the University of California.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted provided
 * that: (1) source distributions retain this entire copyright notice and
 * comment, and (2) distributions including binaries display the following
 * acknowledgement:  ``This product includes software developed by the
 * University of California, Berkeley and its contributors'' in the
 * documentation or other materials provided with the distribution and in
 * all advertising materials mentioning features or use of this software.
 * Neither the name of the University nor the names of its contributors may
 * be used to endorse or promote products derived from this software without
 * specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 *
 *	@(#)machlimits.h	7.2 (Berkeley) 6/28/90
 */

#define	CHAR_BIT	8		/* number of bits in a char */
#define	CLK_TCK		60		/* ticks per second */
#define	MB_LEN_MAX	1		/* no multibyte characters */

#define	SCHAR_MAX	0x7f		/* min value for a signed char */
#define	SCHAR_MIN	(-0x80)		/* max value for a signed char */

#define	UCHAR_MAX	0xff		/* max value for an unsigned char */

#ifdef __CHAR_UNSIGNED__
#define	CHAR_MAX	UCHAR_MAX	/* max value for a char */
#define	CHAR_MIN	0		/* min value for a char */
#else
#define	CHAR_MAX	SCHAR_MAX	/* max value for a char */
#define	CHAR_MIN	SCHAR_MIN	/* min value for a char */
#endif

#define	USHRT_MAX	0xffff		/* max value for an unsigned short */
#define	SHRT_MAX	0x7fff		/* max value for a short */
#define	SHRT_MIN	(-0x8000)	/* min value for a short */

#define	UINT_MAX	((unsigned)0xffffffff)	/* max value unsigned int */
#define	INT_MAX		0x7fffffff	/* max value for an int */
#define	INT_MIN		((int)0x80000000)	/* min value for an int */

#define	ULONG_MAX	((unsigned long)0xffffffff)	/* max unsigned long */
#define	LONG_MAX	((long)0x7fffffff)	/* max value for a long */
#define	LONG_MIN	((long)0x80000000)	/* min value for a long */
